var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import exceptionalError from 'exceptionalhandler';
import * as shopAPI from './shopify.api.js';
export function getProductList() {
    return __awaiter(this, void 0, void 0, function* () {
        const productList = {};
        const allProducts = yield shopAPI.shopify.rest.Product.all({
            session: shopAPI.shopSession
        });
        if (!allProducts.hasOwnProperty("data")) {
            throw new exceptionalError("Failed to get product list - data field was empty");
        }
        for (const productEntry of allProducts.data) {
            if (productEntry.variants) {
                for (const variant of productEntry.variants) {
                    const newEntry = {
                        mainId: String(productEntry.id),
                        mainTitle: productEntry.title,
                        variantSKU: variant.sku,
                        variantTitle: variant.title,
                        qty: variant.inventory_quantity
                    };
                    productList[String(variant.id)] = newEntry;
                }
            }
            else {
                throw new exceptionalError(`Ran across null/empty variants?`);
            }
        }
        return productList;
    });
}
