import exceptionalError from 'exceptionalhandler';
export function isValEmpty(argToCheck) {
    if (argToCheck === null || argToCheck === undefined || argToCheck === "" || (Array.isArray(argToCheck) && argToCheck.length === 0)) {
        return true;
    }
    return false;
}
export function roundCashToString(cashIn) {
    return parseFloat(String(cashIn)).toFixed(2);
}
export function checkAllFields(fieldsToCheck, targetObject, fieldtype, mandatoryType = null) {
    for (const mandatoryField of fieldsToCheck) {
        if (isValEmpty(targetObject[mandatoryField])) {
            throw new exceptionalError(`${fieldtype} field ${mandatoryField} is mandatory`);
        }
        if (mandatoryType) {
            if (typeof targetObject[mandatoryField] !== mandatoryType) {
                throw new exceptionalError(`${fieldtype} field ${mandatoryField} must be a ${mandatoryType}`);
            }
        }
    }
}
