//@ts-nocheck
import util from 'util';
export function checkPost(opts) {
    let expectBody = "";
    let returnBody = "";
    const url = opts.url;
    if (url.match(/fulfillments.json$/)) {
        if (opts.body.match(/order_id":12345/)) {
            expectBody = '{"fulfillment":{"line_items_by_fulfillment_order":[{"fulfillment_order_id":12345}],"tracking_info":{"number":"someTracking","company":"USPS","url":"https://www.vocm.com/track?=someTracking"},"notify_customer":false}}';
        }
        else if (opts.body.match(/12121212/)) {
            expectBody = JSON.stringify({
                fulfillment: {
                    line_items_by_fulfillment_order: [
                        { fulfillment_order_id: 12121212 },
                        { fulfillment_order_id: 2 },
                        { fulfillment_order_id: 3 }
                    ],
                    tracking_info: { number: 'QQQQQ', company: 'Canada Post' },
                    notify_customer: true
                }
            });
        }
    }
    else if (url.match(/orders.json$/)) {
        if (opts.body.match(/someorder1234/i)) {
            expectBody = '{"order":{"email":"some@thing.com","fulfillment_status":null,"send_receipt":true,"send_fulfillment_receipt":true,"name":"someOrder1234","currency":"USD","test":false,"shipping_address":{"first_name":"Chris","last_name":"Nevin","address1":"56 Brodie St","city":"New York","country_code":"US","province_code":"NY","name":"Chris Nevin","zip":"12345","address2":"fasdadafq","phone":"13657940654","company":"incCo"},"line_items":[{"quantity":5,"price":"50.00","variant_id":123456,"name":"someVariantTitle","title":"someThing"}],"total_line_items_price":"250.00","total_tax":"10.00","total_shipping_price_set":{"shop_money":{"amount":"2.00","currency_code":"USD"},"presentment_money":{"amount":"2.00","currency_code":"USD"}},"total_price":"236.50","total_discounts":25.5,"shipping_lines":[{"custom":true,"price":"2.00","title":"Standard"}]}}';
        }
        else if (opts.body.match(/somenewordernumber/i)) {
            expectBody = '{"order":{"email":"some@dude.com","fulfillment_status":null,"name":"someNewOrderNumber","currency":"USD","test":true,"shipping_address":{"first_name":"firstName","last_name":"lastName","address1":"1234 Something Street","city":"someVille","country_code":"JP","province_code":"HI","name":"firstName lastName","zip":"12345"},"line_items":[{"quantity":13,"price":"43.12","variant_id":123456,"name":"hello I am a variant!","title":"yert"}],"total_line_items_price":"560.56","total_tax":"0.00","total_shipping_price_set":{"shop_money":{"amount":"25.00","currency_code":"USD"},"presentment_money":{"amount":"25.00","currency_code":"USD"}},"total_price":"0.00","total_discounts":"585.56","send_receipt":false,"send_fulfillment_receipt":false,"tags":"From SF","shipping_lines":[{"custom":true,"price":"25.00","title":"Priority"}]}}';
            returnBody = {
                "order": {
                    "id": 1073459971,
                    "admin_graphql_api_id": "gid://shopify/Order/1073459971",
                    "app_id": 755357713,
                    "browser_ip": null,
                    "buyer_accepts_marketing": false,
                    "cancel_reason": null,
                    "cancelled_at": null,
                    "cart_token": null,
                    "checkout_id": null,
                    "checkout_token": null,
                    "client_details": null,
                    "closed_at": null,
                    "confirmation_number": "HD28NJCFQ",
                    "confirmed": true,
                    "contact_email": null,
                    "created_at": "2023-08-16T13:18:07-04:00",
                    "currency": "EUR",
                    "current_subtotal_price": "224.97",
                    "current_subtotal_price_set": {
                        "shop_money": {
                            "amount": "224.97",
                            "currency_code": "EUR"
                        },
                        "presentment_money": {
                            "amount": "224.97",
                            "currency_code": "EUR"
                        }
                    },
                    "current_total_additional_fees_set": null,
                    "current_total_discounts": "0.00",
                    "current_total_discounts_set": {
                        "shop_money": {
                            "amount": "0.00",
                            "currency_code": "EUR"
                        },
                        "presentment_money": {
                            "amount": "0.00",
                            "currency_code": "EUR"
                        }
                    },
                    "current_total_duties_set": null,
                    "current_total_price": "238.47",
                    "current_total_price_set": {
                        "shop_money": {
                            "amount": "238.47",
                            "currency_code": "EUR"
                        },
                        "presentment_money": {
                            "amount": "238.47",
                            "currency_code": "EUR"
                        }
                    },
                    "current_total_tax": "13.50",
                    "current_total_tax_set": {
                        "shop_money": {
                            "amount": "13.50",
                            "currency_code": "EUR"
                        },
                        "presentment_money": {
                            "amount": "13.50",
                            "currency_code": "EUR"
                        }
                    },
                    "customer_locale": null,
                    "device_id": null,
                    "discount_codes": [],
                    "email": "",
                    "estimated_taxes": false,
                    "financial_status": "paid",
                    "fulfillment_status": null,
                    "landing_site": null,
                    "landing_site_ref": null,
                    "location_id": null,
                    "merchant_of_record_app_id": null,
                    "name": "#1002",
                    "note": null,
                    "note_attributes": [],
                    "number": 2,
                    "order_number": 1002,
                    "order_status_url": "https://jsmith.myshopify.com/548380009/orders/1c0d5f528eee5ab6eed2bf50aa263855/authenticate?key=b756bb79e55165288a05299ee4f1e493",
                    "original_total_additional_fees_set": null,
                    "original_total_duties_set": null,
                    "payment_gateway_names": [
                        ""
                    ],
                    "phone": null,
                    "po_number": null,
                    "presentment_currency": "EUR",
                    "processed_at": "2023-08-16T13:18:07-04:00",
                    "reference": null,
                    "referring_site": null,
                    "source_identifier": null,
                    "source_name": "755357713",
                    "source_url": null,
                    "subtotal_price": "224.97",
                    "subtotal_price_set": {
                        "shop_money": {
                            "amount": "224.97",
                            "currency_code": "EUR"
                        },
                        "presentment_money": {
                            "amount": "224.97",
                            "currency_code": "EUR"
                        }
                    },
                    "tags": "",
                    "tax_exempt": false,
                    "tax_lines": [
                        {
                            "price": "13.50",
                            "rate": 0.06,
                            "title": "State tax",
                            "price_set": {
                                "shop_money": {
                                    "amount": "13.50",
                                    "currency_code": "EUR"
                                },
                                "presentment_money": {
                                    "amount": "13.50",
                                    "currency_code": "EUR"
                                }
                            },
                            "channel_liable": null
                        }
                    ],
                    "taxes_included": false,
                    "test": false,
                    "token": "1c0d5f528eee5ab6eed2bf50aa263855",
                    "total_discounts": "0.00",
                    "total_discounts_set": {
                        "shop_money": {
                            "amount": "0.00",
                            "currency_code": "EUR"
                        },
                        "presentment_money": {
                            "amount": "0.00",
                            "currency_code": "EUR"
                        }
                    },
                    "total_line_items_price": "224.97",
                    "total_line_items_price_set": {
                        "shop_money": {
                            "amount": "224.97",
                            "currency_code": "EUR"
                        },
                        "presentment_money": {
                            "amount": "224.97",
                            "currency_code": "EUR"
                        }
                    },
                    "total_outstanding": "0.00",
                    "total_price": "238.47",
                    "total_price_set": {
                        "shop_money": {
                            "amount": "238.47",
                            "currency_code": "EUR"
                        },
                        "presentment_money": {
                            "amount": "238.47",
                            "currency_code": "EUR"
                        }
                    },
                    "total_shipping_price_set": {
                        "shop_money": {
                            "amount": "0.00",
                            "currency_code": "EUR"
                        },
                        "presentment_money": {
                            "amount": "0.00",
                            "currency_code": "EUR"
                        }
                    },
                    "total_tax": "13.50",
                    "total_tax_set": {
                        "shop_money": {
                            "amount": "13.50",
                            "currency_code": "EUR"
                        },
                        "presentment_money": {
                            "amount": "13.50",
                            "currency_code": "EUR"
                        }
                    },
                    "total_tip_received": "0.00",
                    "total_weight": 0,
                    "updated_at": "2023-08-16T13:18:07-04:00",
                    "user_id": null,
                    "billing_address": null,
                    "customer": null,
                    "discount_applications": [],
                    "fulfillments": [],
                    "line_items": [
                        {
                            "id": 1071823180,
                            "admin_graphql_api_id": "gid://shopify/LineItem/1071823180",
                            "fulfillable_quantity": 3,
                            "fulfillment_service": "manual",
                            "fulfillment_status": null,
                            "gift_card": false,
                            "grams": 1300,
                            "name": "Big Brown Bear Boots",
                            "price": "74.99",
                            "price_set": {
                                "shop_money": {
                                    "amount": "74.99",
                                    "currency_code": "EUR"
                                },
                                "presentment_money": {
                                    "amount": "74.99",
                                    "currency_code": "EUR"
                                }
                            },
                            "product_exists": false,
                            "product_id": null,
                            "properties": [],
                            "quantity": 3,
                            "requires_shipping": true,
                            "sku": null,
                            "taxable": true,
                            "title": "Big Brown Bear Boots",
                            "total_discount": "0.00",
                            "total_discount_set": {
                                "shop_money": {
                                    "amount": "0.00",
                                    "currency_code": "EUR"
                                },
                                "presentment_money": {
                                    "amount": "0.00",
                                    "currency_code": "EUR"
                                }
                            },
                            "variant_id": null,
                            "variant_inventory_management": null,
                            "variant_title": null,
                            "vendor": null,
                            "tax_lines": [
                                {
                                    "channel_liable": null,
                                    "price": "13.50",
                                    "price_set": {
                                        "shop_money": {
                                            "amount": "13.50",
                                            "currency_code": "EUR"
                                        },
                                        "presentment_money": {
                                            "amount": "13.50",
                                            "currency_code": "EUR"
                                        }
                                    },
                                    "rate": 0.06,
                                    "title": "State tax"
                                }
                            ],
                            "duties": [],
                            "discount_allocations": []
                        }
                    ],
                    "payment_terms": null,
                    "refunds": [],
                    "shipping_address": null,
                    "shipping_lines": []
                }
            };
        }
    }
    else if (url.match(/close.json$/)) {
        expectBody = '';
    }
    else if (url.match(/discount_codes.json$/)) {
        expectBody = '{"discount_code":{"code":"QQf5FD","price_rule_id":123456789}}';
        returnBody = {
            "code": "SUMMERSALE10OFF",
            "created_at": "2017-03-13T16:09:54-04:00",
            "updated_at": "2017-03-13T16:09:54-04:00",
            "id": 9808080986,
            "price_rule_id": 423748927342,
            "usage_count": 3,
            "errors": {
                "code": [
                    "must be unique. Please try a different code."
                ]
            }
        };
    }
    else if (url.match(/price_rules.json$/)) {
        // gotta remove the date stuff because it's now()
        if (opts.body.match(/fixed_amount/i)) {
            expectBody = '{"price_rule":{"title":"Absolute Itme Rule","usage_limit":4,"customer_selection":"all","target_selection":"all","target_type":"line_item","allocation_method":"across","value_type":"fixed_amount","value":"-101.00"}}';
            returnBody = { "price_rule": { "id": 123456789, "value_type": "percentage", "value": "-100.0", "customer_selection": "all", "target_type": "line_item", "target_selection": "entitled", "allocation_method": "each", "allocation_limit": 3, "once_per_customer": false, "usage_limit": null, "starts_at": "2018-03-21T20:00:00-04:00", "ends_at": null, "created_at": "2023-07-11T18:37:53-04:00", "updated_at": "2023-07-11T18:37:53-04:00", "entitled_product_ids": [921728736], "entitled_variant_ids": [], "entitled_collection_ids": [], "entitled_country_ids": [], "prerequisite_product_ids": [], "prerequisite_variant_ids": [], "prerequisite_collection_ids": [841564295], "customer_segment_prerequisite_ids": [], "prerequisite_customer_ids": [], "prerequisite_subtotal_range": null, "prerequisite_quantity_range": null, "prerequisite_shipping_price_range": null, "prerequisite_to_entitlement_quantity_ratio": { "prerequisite_quantity": 2, "entitled_quantity": 1 }, "prerequisite_to_entitlement_purchase": { "prerequisite_amount": null }, "title": "Buy2iPodsGetiPodTouchForFree", "admin_graphql_api_id": "gid://shopify/PriceRule/996606715" } };
        }
        else if (opts.body.match(/percentage/)) {
            expectBody = '{"price_rule":{"title":"Percent Shipping Rule","usage_limit":4,"customer_selection":"all","target_selection":"all","target_type":"shipping_line","allocation_method":"each","value_type":"percentage","value":"-100.00"}}';
            returnBody = { "price_rule": { "id": 987654321, "value_type": "percentage", "value": "-100.0", "customer_selection": "all", "target_type": "line_item", "target_selection": "entitled", "allocation_method": "each", "allocation_limit": 3, "once_per_customer": false, "usage_limit": null, "starts_at": "2018-03-21T20:00:00-04:00", "ends_at": null, "created_at": "2023-07-11T18:37:53-04:00", "updated_at": "2023-07-11T18:37:53-04:00", "entitled_product_ids": [921728736], "entitled_variant_ids": [], "entitled_collection_ids": [], "entitled_country_ids": [], "prerequisite_product_ids": [], "prerequisite_variant_ids": [], "prerequisite_collection_ids": [841564295], "customer_segment_prerequisite_ids": [], "prerequisite_customer_ids": [], "prerequisite_subtotal_range": null, "prerequisite_quantity_range": null, "prerequisite_shipping_price_range": null, "prerequisite_to_entitlement_quantity_ratio": { "prerequisite_quantity": 2, "entitled_quantity": 1 }, "prerequisite_to_entitlement_purchase": { "prerequisite_amount": null }, "title": "Buy2iPodsGetiPodTouchForFree", "admin_graphql_api_id": "gid://shopify/PriceRule/996606715" } };
        }
        else {
            throw '!?!??!?!';
        }
        opts.body = opts.body.replace(/"(?:starts|ends)_at":".+?",/g, "");
    }
    else {
        console.log(`wut URL ${url}`);
        console.log(opts.body);
        throw `wut URL ${url}`;
    }
    if (opts.body !== expectBody) {
        console.log(`Bad body - throwing and timing out`);
        console.log(util.inspect(opts.body));
        console.log('UP THERE ^^');
        throw "ASDADADSADASDASD";
    }
    return returnBody;
}
